=== bindings/gnome2/CMakeLists.txt ===
# Order is important here.  lib must be first since python depends upon it.
add_subdirectory(lib) 
add_subdirectory(python)
