=== debian/changelog ===
pftools (3.2.12-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with nocheck build profile. Closes: #1103318.
    Thanks to Nilesh Patra.
  * Enable nocheck build profile job in Salsa CI.
  * Drop "Rules-Requires-Root: no", no longer needed.
  * Upldate lintian overrides.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sat, 27 Sep 2025 22:55:00 +0200

pftools (3.2.12-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 3.2.12
  * Refresh patches
  * d/rules:
    + Re-enable regex support now that pcre2 support is added
    + Add linker flags for pcre2 to LDFLAGS
  * d/control: Add libpcre2-dev to B-D

 -- Nilesh Patra <nilesh@debian.org>  Sat, 26 Mar 2022 21:23:28 +0530
